#!/usr/bin/perl -w
#
# Test whether a port (22/ssh) is listening and return good or bad status 
# st7392020@gmail.com
###############################################################################
use strict;
use warnings;
use Socket;

my $shell_true=0;
my $shell_false=1;

{
   if (scalar(@ARGV) != 2){
		print STDERR "knock target port\n";
		exit($shell_false);
	}
   my ($target, $port) =@ARGV;
   my ($iaddr, $paddr, $proto);
   if ($port =~ /\D/) { $port = getservbyname($port, "tcp") }
   exit($shell_false) unless $port;
   $iaddr   = inet_aton($target) || exit($shell_false);
   $paddr   = sockaddr_in($port, $iaddr);
   $proto   = getprotobyname("tcp");
   socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || exit($shell_false);
	eval {
		local $SIG{ALRM} = sub { print STDERR "connect timeout\n" ; return $shell_false; };
		alarm 3;
		eval {
			connect(SOCK, $paddr) || exit($shell_false);
		};
		alarm 0;
	};
	alarm 0;
   close (SOCK) || exit($shell_false);
   exit($shell_true);
}
